codeforces 711D. Directed Roads 找环

D. Directed Roads
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

ZS the Coder and Chris the Baboon has explored Udayland for quite some time. They realize that it consists ofn towns numbered from1 ton.

There are n directed roads in the Udayland.i-th of them goes from towni to some other townai (ai ≠ i). ZS the Coder can flip the direction of any road in Udayland, i.e. if it goes from townA to townB before the flip, it will go from townB to townA after.

ZS the Coder considers the roads in the Udayland confusing, if there is a sequence of distinct towns A1, A2, ..., Ak (k > 1) such that for every1 ≤ i < k there is a road from townAi to townAi + 1 and another road from townAk to townA1. In other words, the roads are confusing ifsome of them form a directed cycle of some towns.

Now ZS the Coder wonders how many sets of roads (there are 2n variants) in initial configuration can he choose to flip such that after flipping each road in the set exactly once, the resulting network willnot be confusing.

Note that it is allowed that after the flipping there are more than one directed road from some town and possibly some towns with no roads leading out of it, or multiple roads between any pair of cities.

Input

The first line of the input contains single integer n (2 ≤ n ≤ 2·105) — the number of towns in Udayland.

The next line contains n integers a1, a2, ..., an(1 ≤ ai ≤ n, ai ≠ i),ai denotes a road going from towni to town ai.

Output

Print a single integer — the number of ways to flip some set of the roads so that the resulting whole set of all roads is not confusing. Since this number may be too large, print the answer modulo109 + 7.

Examples
Input
3
2 3 1
Output
6
Input
4
2 1 1 1
Output
8
Input
5
2 4 2 5 3
Output
28
Note

Consider the first sample case. There are 3 towns and3 roads. The towns are numbered from1 to3 and the roads are,, initially. Number the roads1 to 3 in this order.

The sets of roads that ZS the Coder can flip (to make them not confusing) are {1}, {2}, {3}, {1, 2}, {1, 3}, {2, 3}. Note that the empty set is invalid because if no roads are flipped, then towns1, 2, 3 is form a directed cycle, so it is confusing. Similarly, flipping all roads is confusing too. Thus, there are a total of6 possible sets ZS the Coder can flip.

The sample image shows all possible ways of orienting the roads from the first sample such that the network isnot confusing.


题意:给一个图,n个点n条边,每条边可以反方向,问有多少种方案使得图中没有环。

解法,只需要找出图中的环,任意改变(大于等于1小于n条)多少条边,都可以使得一个环不是环。一个环的方案数就是C(1,n)+C(2,n)+C(3,n)+...C(n-1,n),这个组合数的和为2的n次方减2.把每个环的方案数求出来乘起来就行了。剩余不是环的边可以随便取不取,再乘一个2的剩余边的次方就行了。


#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
const int N = 2e5+10;
const LL mod = 1e9+7;
int n;
int a[N];  
int vis[N];
LL cnt;
LL ans;
int deps[N]; ///深度,用于记录一个环有多少条边

LL Pow(LL a,LL b,LL mod)
{
    LL ret = 1;
    LL A = a;
    while(b){
        if(b&1) ret = A*ret%mod;
        A = A*A%mod;
        b >>= 1;
    }
    return ret;
}

void dfs(int u,int dep,int fa)
{
    vis[u] = fa;  ///相同分量设置为同一个标记
    deps[u] = dep;
    if(!vis[a[u]]) dfs(a[u],dep+1,fa);
    else{
        if(vis[a[u]] == vis[u]){
            ans = ans*(Pow(2,deps[u]-deps[a[u]]+1,mod)-2)%mod;
            cnt += deps[u]-deps[a[u]]+1;
        }
    }
}

int main(void)
{
    int n;
    ans = 1;
    scanf("%d",&n);
    for(int i = 1;i <= n;i++) scanf("%d",&a[i]);
    for(int i = 1;i <= n;i++){
        if(!vis[i]){
            dfs(i,1,i);
        }
    }
    ans = ans*(Pow(2,n-cnt,mod))%mod;
    printf("%I64d",ans);
    return 0;
}


CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值